#-------------------------------------------------------------------------------
#
# Copyright (c) QUALCOMM Inc. 2001, 2002, 2003, 2004, 2005, 2007
#
# $Header: //depot/asic/qsc60x0/build/ms/dmss_qsc60x0.mak#35 $ $DateTime: 2007/10/17 05:07:12 $ $Author: jshriram $
#
#-------------------------------------------------------------------------------

ifeq ($(USES_MINI_DLOADER),yes)
        all : build_start dmss build_mini_dloader build_end
else
        all : build_start dmss build_end
endif

#-------------------------------------------------------------------------------
# Path to ARM 1.2 tools
#-------------------------------------------------------------------------------
ARMHOME := $(subst \,/,$(ARMHOME))

ifeq ($(USES_ROMBOOT),yes) 
	ifeq ($(USES_SECBOOT),yes)
		SEC_MODE = sec
	else
		SEC_MODE = nonsec
	endif
	export SEC_MODE
endif #USES_ROMBOOT
#------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
# Component types
#-------------------------------------------------------------------------------
FLASH_TYPE = nor
#-------------------------------------------------------------------------------
#
#-------------------------------------------------------------------------------
include dmss_flags.min
include incpaths.min
include dmss_$(ASIC)_flags.min
include armtools.min
-include amss_lint_flags.min

ifeq ($(USES_META), yes)
-include $(METAFILE)/MetaFilesSrcMin.min
-include $(METAFILE)/Qfiles.min
-include $(METAFILE)/MetaFilesAll.min
-include $(METAFILE)/MetaFilesCfg.min
-include $(METAFILE)/MetaLibs.min
endif # USES_META 

ifeq ($(USES_ROMBOOT),yes)
	include boot_targets_version_$(SEC_MODE).min
	include boot_targets_$(SEC_MODE).min
	include boot_targets_cfgdata.min
endif #USES_ROMBOOT

build_start:
	@$(BTIME) -start build_time.bt -b

build_end: dmss   # added dependency so timing for parallel builds is accurate
	@$(BTIME) -end build_time.bt -b

build_mini_dloader:
	@$(MAKE) -C $(MINI_DLOADER) -f mini_dloader.mak CUSTNAME=$(TARGET) all

ifeq ($(USES_META), yes)
#########################PKI 㷨#################################
#PKI 㷨
RSA=	 $(SRCROOT)/tools/hostdl/SHA_RSA/rsa
SHA=	 $(SRCROOT)/tools/hostdl/SHA_RSA/sha
COMM=	 $(SRCROOT)/tools/hostdl/SHA_RSA/comm
KEY=	 $(SRCROOT)/tools/hostdl/SHA_RSA/Key

SMP=	 $(SRCROOT)/tools/hostdl/SMP

#ALL_PATHS+= $(RSA) $(SHA) $(COMM) $(KEY) $(SMP)
ALL_INCLUDES+= $(addprefix -I,$(RSA) $(SHA) $(COMM) $(KEY) $(SMP))

#PKI 㷨
include $(RSA)/rsa.min
include $(SHA)/sha.min
include $(KEY)/key.min
include $(COMM)/comm.min
include $(SMP)/smp.min


PUBLIC_OBJECTS =$(subst $(TARGET),$(TARGETDIR),$(SHA_OBJS)) \
				$(subst $(TARGET),$(TARGETDIR),$(RSA_OBJS)) \
				$(subst $(TARGET),$(TARGETDIR),$(KEY_OBJS)) \
				$(subst $(TARGET),$(TARGETDIR),$(COMM_OBJS)) \
				$(subst $(TARGET),$(TARGETDIR),$(SMP_OBJS))

####################################################################
endif # USES_META 

include dmss_objects.min

#-------------------------------------------------------------------------------
# Object groups that are specific to this target
#-------------------------------------------------------------------------------
# INSERT OBJECTS MACROS HERE
# Build the full object list for this target
OBJECTS = \
                $(REX_OBJS) \
                $(ACP_OBJS) \
                $(ADC_OBJS)  \
                $(ADIE_OBJS) \
                $(ADSP_OBJS) \
                $(ANSIC_OBJS) \
                $(ATMR_OBJS) \
                $(AUDFMT_OBJS) \
                $(AVS_OBJS) \
                $(BIO_OBJS) \
                $(BOOT_OBJS) \
                $(CHG_OBJS) \
                $(CLK_OBJS) \
                $(CLKREGIM_OBJS) \
                $(CM_OBJS) \
                $(CMX_OBJS) \
                $(COREAPP_OBJS) \
                $(DATA_OBJS) \
                $(DCP_OBJS) \
                $(DEC_OBJS) \
                $(DH_OBJS) \
                $(DSM_OBJS) \
                $(DIAG_OBJS) \
                $(DLOAD_OBJS) \
                $(DEMOD_OBJS) \
                $(ENC_OBJS) \
                $(FS_OBJS) \
                $(FTM_RF_OBJS) \
                $(HS_OBJS) \
                $(HS_SURF_OBJS) \
                $(HW_OBJS) \
                $(I2C_OBJS) \
                $(KPD_OBJS) \
                $(LCD_SURF_OBJS) \
                $(MDSP_OBJS) \
                $(MDSPSVC_OBJS) \
		$(MMOC_OBJS) \
                $(MUX_OBJS) \
                $(MVS_OBJS) \
		$(NVIM_OBJS) \
                $(PMAPP_GEN_OBJS) \
                $(PMAPP_OTG_OBJS) \
                $(QDSP_OBJS) \
                $(RF_MM_API_OBJS) \
                $(RF_OBJS) \
                $(SAM_OBJS) \
                $(SD_OBJS) \
                $(SDAC_OBJS) \
                $(SEC_OBJS) \
                $(SIO_OBJS) \
                $(SLEEP_OBJS) \
                $(SLEEP_1X_OBJS) \
                $(SRCH_OBJS) \
                $(TASK_OBJS) \
                $(TCXOMGR_OBJS) \
                $(THERM_OBJS) \
                $(TIME_OBJS) \
                $(TLMM_OBJS) \
                $(TMC_OBJS) \
                $(TRAMP_OBJS) \
                $(UI_OBJS) \
                $(USB_OBJS) \
                $(UTILS_OBJS) \
                $(VBATT_OBJS) \
                $(VS_OBJS) \
                $(VDB_OBJS) \
                $(WMS_OBJS) \
		$(XMLLIB_OBJS) \
                $(PROFILE_OBJS)

OBJECTS2 = \
                $(APPMGR_OBJS) \
                $(CONTACT_OBJS) \
                $(DIALERAPP_OBJS) \
                $(FLDDBG_OBJS) \
                $(GRAPH_OBJS) \
                $(JPEG_OBJS) \
                $(PNG_OBJS) \
                $(RECENTCALLS_OBJS) \
                $(WMSAPP_OBJS) \
		$(OEM_OBJS) \
		$(EXT_OEM_OBJS) \
                $(SVCPRG_OBJS) \
                $(RTE_OBJS) 
ifeq ($(USES_META), yes)
OBJECTS += $(PBM_OBJS) \
	$(META_AUTO_OBJS) \
	$(PUBLIC_OBJECTS)

endif # USES_META 
		
#-------------------------------------------------------------------------------
# Object List Modifiers
#    Alter the object list based on the requested features
#-------------------------------------------------------------------------------

ifneq ($(USES_THINUI),yes)
       OBJECTS += $(OBJECTS2)
endif 
	
ifeq ($(USES_PROFDIAG), yes)
        OBJECTS += $(PROFDIAG_OBJS)
endif

ifeq ($(USES_HWTC),yes)
    # *** Need to be first to be able to change defult DMSS settins to default HWTC settings
    include $(HWTC)/hwtc_flags.min
endif

ifeq ($(USES_RUIM),yes)
        OBJECTS += $(RUIM_OBJS) $(NVIM_RUIM_OBJS) $(MMGSDI_OBJS)
endif

ifeq ($(USES_RUIM6010),yes)
        OBJECTS += $(RUIM_OBJS) $(NVIM_RUIM_OBJS) $(MMGSDI_OBJS)
endif

ifeq ($(USES_GSTK),yes)
	OBJECTS += $(GSTK_OBJS)
	OBJECTS += $(CATAPP_OBJS)
endif

ifeq ($(USES_AUTH),yes)
        OBJECTS += $(AUTH_OBJS)
endif

ifeq ($(USES_MMC),yes)
        OBJECTS += $(MMC_OBJS)
endif

ifeq ($(USES_PLT),yes)
        OBJECTS += $(PLT_OBJS) $(RPC_OBJS)
endif

ifeq ($(USES_FTM),yes)
        OBJECTS += $(FTM_OBJS)
  ifeq ($(USES_FTM_HWTC),yes)
          OBJECTS += $(FTM_HWTC_OBJS)
  endif
endif

ifeq ($(USES_QFUSE),yes)
        OBJECTS += $(EFUSE_OBJS)
endif

ifeq ($(USES_MP4),yes)
        OBJECTS += $(MODLAB_OBJS)
ifeq ($(USES_QCAMCORDER),yes)
        OBJECTS += $(CAMCORDER_OBJS)
ifneq ($(USES_META), yes)
        OBJECTS += $(QCAMCORDER_OBJS)
endif # USES_META 
endif
        OBJECTS += $(QTV_BSD_OBJS)
        OBJECTS += $(VIDEOFMT_OBJS)
        OBJECTS += $(TARGETDIR)/qtv_app.lib
        OBJECTS += $(TARGETDIR)/qtv_common.lib
ifeq ($(USES_MP4DEC), yes)
        OBJECTS += $(TARGETDIR)/qtv_dec.lib
endif
endif

ifeq ($(USES_AAC),yes)
        OBJECTS += $(AUDFMT_MPEG_OBJS)
endif

ifeq ($(USES_REAL),yes)
        OBJECTS += $(AUDFMT_REAL_AUDIO_OBJS)
        OBJECTS += $(QTV_REAL_OBJS)
    ifeq ($(USES_MP4),no)
            OBJECTS += $(QTV_BSD_OBJS)
    endif
endif

ifeq ($(USES_BT),yes)
        OBJECTS += $(BT_OBJS)
  ifeq ($(USES_IBT),yes)
	  OBJECTS += $(BTAPP_OBJS)
  endif
endif

ifeq ($(USES_STA),yes)
        OBJECTS += $(STA_OBJS)
endif

ifeq ($(USES_VRSD),yes)
        OBJECTS := $(filter-out $(PUREVOICE_OBJS), $(OBJECTS))
endif

ifeq ($(USES_EFS2),yes)
        OBJECTS += $(EFS_OBJS)
       	OBJECTS += $(FLASH_OBJS)
endif

ifeq ($(USES_CMX),yes)
        OBJECTS += $(AUDFMT_CMX_OBJS)
endif

ifeq ($(USES_AUDFMT_AMR),yes)
        OBJECTS += $(AMRSUP_OBJS)
endif

ifeq ($(USES_GRP),yes)
        OBJECTS += $(GRP_OBJS)
endif

ifeq ($(USES_GIGA),yes)
	OBJECTS += $(CALMON_OBJS)
endif

ifeq ($(USES_GLES_CL),yes)
        #
        # Demo Applications for OpenGLES Common Lite
        #
        OBJECTS += $(OGLES_SAMPLES_OBJS)
        #
        # OpenGLES Firmware Driver
        #
        OBJECTS += $(QGLDRV_OBJS)

endif

ifeq ($(USES_EGL),yes)
	OBJECTS += $(OGLES_OEM_OBJS)
endif

ifeq ($(USES_HWTC), yes)
    # *** HWTC must be last. Need to remove unwanted objects/libraries.

    # HWTC requires the UIM drivers only
    # the hwtc.min will remove unwanted
    # files.
    ifeq ($(USES_RUIM),no)
          OBJECTS += $(RUIM_OBJS)
    endif

    include $(HWTC)/hwtc.min
endif
ifeq ($(USES_NETDIAGNOSTICS),yes)
        OBJECTS += $(NETDIAGNOSTICS_OBJS)
endif

ifeq ($(USES_CAMERA),yes)
        OBJECTS += $(CAMERA_OBJS)
        OBJECTS += $(CAMSENSOR_OBJS)
        OBJECTS += $(QCAMCOMMON_OBJS)
        OBJECTS += $(QCAMERA_OBJS)
        OBJECTS += $(QALBUM_OBJS)
endif

ifeq ($(USES_IPL),yes)
        OBJECTS += $(IPL_OBJS)
endif

ifeq ($(USES_BrewStaticExtensions), yes)
        OBJECTS += $(EXT_MM_LIB_OBJS)
        OBJECTS += $(EXT_UIM_OBJS)
endif

ifeq ($(USES_VRENG),yes)
        OBJECTS += $(VR_OBJS)
        OBJECTS += $(VRE_OBJS)
endif

ifeq ($(USES_VM),yes)
        OBJECTS += $(VM_OBJS)
endif

ifeq ($(USES_MEDIAPLAYER),yes)
        OBJECTS += $(MEDIAPLAYER_OBJS)
endif


#-------------------------------------------------------------------------------
# Message Levels
#    These operate on object groups - so these instructions must appear after
#    all the object groups are named
#-------------------------------------------------------------------------------
include dmss_msg_config.min

#-------------------------------------------------------------------------------
# Dependency Generation
#    Names the location of the dependency file and options to the dependency
#    generator.
#-------------------------------------------------------------------------------
ifeq ($(USES_META),yes)
DEPFILE := $(OUTPUT)/$(PROJECT).dep
else
DEPFILE := $(TARGETDIR)/$(TARGETDIR).dep
endif
DEPOPTS := @dmss_$(ASIC)_depopts.min -d ../.. -bid $(BUILD) -f $(DEPFILE)
ifneq ($(MEM_USAGE),yes)
-include $(DEPFILE)
-include dmss_$(ASIC)_dep.min
endif

#-------------------------------------------------------------------------------
# Memory Usage Generation
#    Generate memory usage for this target
#-------------------------------------------------------------------------------
MEMOPTS := -b $(ASIC)$(BUILD)$(VERSION) -mf $(BUILD).map -lf $(MEMLIST) -sf memsort.lf > $(ASIC)$(BUILD)$(VERSION).mem.html

#-------------------------------------------------------------------------------
# Media File Copy Script 
#   Script to copy various media, bar files, mif files, mod files, etc. to the
#   loadefs directory for packaging into HXB files
#-------------------------------------------------------------------------------
MEDIACOPY = dmss_qsc60x0_mediacopy.cmd

OBJDIR = $(TARGETDIR)

#-------------------------------------------------------------------------------
# Build Rules
#-------------------------------------------------------------------------------
include dmss_rules.min
-include amss_lint_rules.min
